<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>lib.plot.plot_hist &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      <li>lib.plot.plot_hist</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for lib.plot.plot_hist</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Plot production factory for histograms.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Union</span><span class="p">,</span> <span class="n">List</span><span class="p">,</span> <span class="n">Tuple</span>
<span class="kn">from</span> <span class="nn">.._typing</span> <span class="kn">import</span> <span class="n">SamplesLike</span><span class="p">,</span> <span class="n">Density</span>

<span class="kn">import</span> <span class="nn">matplotlib</span> <span class="k">as</span> <span class="nn">mpl</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>

<span class="kn">from</span> <span class="nn">..handle.handle_list</span> <span class="kn">import</span> <span class="n">el_to_list</span>
<span class="kn">from</span> <span class="nn">..handle.handle_hist</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">get_centres_edges_from_bins</span><span class="p">,</span> <span class="n">dataframes_into_hist_1d</span>
<span class="p">)</span>
<span class="kn">from</span> <span class="nn">.</span> <span class="kn">import</span> <span class="n">tools</span>
<span class="kn">from</span> <span class="nn">.label</span> <span class="kn">import</span> <span class="n">set_label_hist</span>


<div class="viewcode-block" id="plot_one_hist_from_counts"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.plot_hist.plot_one_hist_from_counts">[docs]</a><span class="k">def</span> <span class="nf">plot_one_hist_from_counts</span><span class="p">(</span>
    <span class="n">ax</span><span class="p">:</span> <span class="n">mpl</span><span class="o">.</span><span class="n">axes</span><span class="o">.</span><span class="n">Axes</span><span class="p">,</span> <span class="n">counts</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">bins</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span>
    <span class="n">err</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">color</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Tuple</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">str</span><span class="p">]]</span> <span class="o">=</span> <span class="s1">&#39;b&#39;</span><span class="p">,</span> <span class="n">linestyle</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s1">&#39;-&#39;</span><span class="p">,</span>
    <span class="n">linewidth</span><span class="p">:</span> <span class="nb">float</span> <span class="o">=</span> <span class="mi">2</span><span class="p">,</span> <span class="n">edgecolor</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">alpha</span><span class="p">:</span> <span class="nb">float</span> <span class="o">=</span> <span class="mf">1.</span><span class="p">,</span>
    <span class="n">bar_mode</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">bool</span><span class="p">,</span> <span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span>
    <span class="n">label</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">show_ncounts</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
    <span class="n">show_xerr</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
    <span class="n">orientation</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="s1">&#39;vertical&#39;</span><span class="p">,</span>
    <span class="n">fix_ticks</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
    <span class="o">**</span><span class="n">kwargs</span>
<span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;  Plot 1D histogram from bin counts and bin edges or centres.</span>

<span class="sd">    * If ``bar_mode``: Points with error bars</span>
<span class="sd">    * Else: histogram with bars</span>

<span class="sd">    Args:</span>
<span class="sd">        ax : axis where to plot</span>
<span class="sd">        counts : bin counts</span>
<span class="sd">        bins : Interpreted as bin centres if there are as many</span>
<span class="sd">            values as bin counts. If there are one less, it is interpreted as</span>
<span class="sd">            bin edges.</span>
<span class="sd">        err : Error on bin counts</span>
<span class="sd">        color : either a colour, or a list of 2 colours if</span>
<span class="sd">            you want to specify different colors for filling and edges.</span>
<span class="sd">            The latter applies only if `bar_mode` is at `True`.</span>
<span class="sd">            If you want to only plot the edges of the histograms, you can</span>
<span class="sd">            set this argument to ``[None, your_colour]``.</span>
<span class="sd">        linestyle: line style of the histogram edges</span>
<span class="sd">        linewidth: line width of the histogram edges</span>
<span class="sd">        alpha: transparency of the bar histogram, between 0. and 1.</span>
<span class="sd">        edgecolor: alternatively, you can choose a edge color</span>
<span class="sd">        bar_mode: whether to plot with bars, or points + error bars</span>
<span class="sd">            or both if ``bar_mode`` is ``both``</span>
<span class="sd">        label : label of the histogram</span>
<span class="sd">        show_ncounts : if True, add the number of counts to the</span>
<span class="sd">            histogram label</span>
<span class="sd">        show_xerr : whether to show the error on the values (along the</span>
<span class="sd">            x-axis).</span>
<span class="sd">        orientation: &#39;vertical&#39; or &#39;horizontal&#39;, orientation of the histogram</span>
<span class="sd">        fix_ticks: whether to fix the tick labels and values of the x-axis</span>
<span class="sd">        **kwargs : parameters passed to the ``ax.bar``, or ``ax.barh`` or</span>
<span class="sd">            ``ax.errorbar`` functions</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># Interprete bins as centres or edges</span>
    <span class="n">centres</span><span class="p">,</span> <span class="n">edges</span> <span class="o">=</span> <span class="n">get_centres_edges_from_bins</span><span class="p">(</span>
        <span class="n">bins</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">counts</span><span class="p">)</span>
    <span class="p">)</span>
    <span class="n">bin_widths</span> <span class="o">=</span> <span class="n">edges</span><span class="p">[</span><span class="mi">1</span><span class="p">:]</span> <span class="o">-</span> <span class="n">edges</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>

    <span class="c1"># Add the number of counts to the label of the plot</span>
    <span class="n">n_candidates</span> <span class="o">=</span> <span class="n">counts</span><span class="o">.</span><span class="n">sum</span><span class="p">()</span>
    <span class="k">if</span> <span class="n">show_ncounts</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">label</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">label</span> <span class="o">+=</span> <span class="s2">&quot; - &quot;</span>
        <span class="n">label</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot; </span><span class="si">{n_candidates}</span><span class="s2"> events&quot;</span>

    <span class="k">if</span> <span class="n">bar_mode</span> <span class="ow">or</span> <span class="n">bar_mode</span> <span class="o">==</span> <span class="s2">&quot;both&quot;</span><span class="p">:</span>
        <span class="n">colors</span> <span class="o">=</span> <span class="n">el_to_list</span><span class="p">(</span><span class="n">color</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">orientation</span> <span class="o">==</span> <span class="s1">&#39;vertical&#39;</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">colors</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">ax</span><span class="o">.</span><span class="n">bar</span><span class="p">(</span><span class="n">centres</span><span class="p">,</span> <span class="n">counts</span><span class="p">,</span> <span class="n">bin_widths</span><span class="p">,</span>
                       <span class="n">color</span><span class="o">=</span><span class="n">colors</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span>
                       <span class="n">alpha</span><span class="o">=</span><span class="n">alpha</span><span class="p">,</span> <span class="n">edgecolor</span><span class="o">=</span><span class="n">edgecolor</span><span class="p">,</span>
                       <span class="n">label</span><span class="o">=</span><span class="n">label</span><span class="p">,</span>
                       <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">colors</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">ax</span><span class="o">.</span><span class="n">step</span><span class="p">(</span><span class="n">edges</span><span class="p">,</span>
                        <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">np</span><span class="o">.</span><span class="n">asarray</span><span class="p">([</span><span class="n">counts</span><span class="p">[</span><span class="mi">0</span><span class="p">]]),</span> <span class="n">counts</span><span class="p">]),</span>
                        <span class="n">color</span><span class="o">=</span><span class="n">colors</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="n">alpha</span><span class="o">=</span><span class="n">alpha</span><span class="p">,</span>
                        <span class="n">label</span><span class="o">=</span><span class="n">label</span> <span class="k">if</span> <span class="n">colors</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="kc">None</span><span class="p">,</span>
                        <span class="n">linestyle</span><span class="o">=</span><span class="n">linestyle</span><span class="p">,</span> <span class="n">linewidth</span><span class="o">=</span><span class="n">linewidth</span><span class="p">,</span>
                        <span class="o">**</span><span class="n">kwargs</span>
                        <span class="p">)</span>
        <span class="k">elif</span> <span class="n">orientation</span> <span class="o">==</span> <span class="s1">&#39;horizontal&#39;</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">colors</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">ax</span><span class="o">.</span><span class="n">barh</span><span class="p">(</span>
                    <span class="n">centres</span><span class="p">,</span> <span class="n">counts</span><span class="p">,</span> <span class="n">edges</span><span class="p">[</span><span class="mi">1</span><span class="p">:]</span> <span class="o">-</span> <span class="n">edges</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">color</span><span class="o">=</span><span class="n">colors</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span>
                    <span class="n">alpha</span><span class="o">=</span><span class="n">alpha</span><span class="p">,</span> <span class="n">edgecolor</span><span class="o">=</span><span class="n">edgecolor</span><span class="p">,</span>
                    <span class="n">label</span><span class="o">=</span><span class="n">label</span> <span class="k">if</span> <span class="n">colors</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="kc">None</span><span class="p">,</span>
                    <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">colors</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">ax</span><span class="o">.</span><span class="n">step</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">(</span>
                    <span class="p">[</span><span class="n">counts</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">counts</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]])]),</span>
                    <span class="n">edges</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="n">colors</span><span class="p">[</span><span class="mi">2</span><span class="p">],</span>
                    <span class="n">linestyle</span><span class="o">=</span><span class="n">linestyle</span><span class="p">,</span> <span class="n">linewidth</span><span class="o">=</span><span class="n">linewidth</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="n">alpha</span>
                <span class="p">)</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">bar_mode</span> <span class="ow">or</span> <span class="n">bar_mode</span> <span class="o">==</span> <span class="s2">&quot;both&quot;</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">show_xerr</span><span class="p">:</span>
            <span class="n">xerr</span> <span class="o">=</span> <span class="n">bin_widths</span> <span class="o">/</span> <span class="mi">2</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">xerr</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="n">orientation</span> <span class="o">==</span> <span class="s1">&#39;vertical&#39;</span><span class="p">:</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">errorbar</span><span class="p">(</span><span class="n">centres</span><span class="p">,</span> <span class="n">counts</span><span class="p">,</span> <span class="n">xerr</span><span class="o">=</span><span class="n">xerr</span><span class="p">,</span> <span class="n">yerr</span><span class="o">=</span><span class="n">err</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="n">color</span><span class="p">,</span>
                        <span class="n">ls</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s1">&#39;.&#39;</span><span class="p">,</span>
                        <span class="n">label</span><span class="o">=</span><span class="n">label</span> <span class="k">if</span> <span class="n">bar_mode</span> <span class="o">!=</span> <span class="s2">&quot;both&quot;</span> <span class="k">else</span> <span class="kc">None</span><span class="p">,</span>
                        <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">orientation</span> <span class="o">==</span> <span class="s1">&#39;horizontal&#39;</span><span class="p">:</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">errorbar</span><span class="p">(</span><span class="n">counts</span><span class="p">,</span> <span class="n">centres</span><span class="p">,</span> <span class="n">xerr</span><span class="o">=</span><span class="n">err</span><span class="p">,</span> <span class="n">yerr</span><span class="o">=</span><span class="n">xerr</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="n">color</span><span class="p">,</span>
                        <span class="n">ls</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s1">&#39;.&#39;</span><span class="p">,</span>
                        <span class="n">label</span><span class="o">=</span><span class="n">label</span> <span class="k">if</span> <span class="n">bar_mode</span> <span class="o">!=</span> <span class="s2">&quot;both&quot;</span> <span class="k">else</span> <span class="kc">None</span><span class="p">,</span>
                        <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>

    <span class="c1"># Reset abscissa limits of the plots</span>
    <span class="n">LOW</span> <span class="o">=</span> <span class="n">edges</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="n">HIGH</span> <span class="o">=</span> <span class="n">edges</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
    <span class="k">if</span> <span class="n">orientation</span> <span class="o">==</span> <span class="s1">&#39;vertical&#39;</span><span class="p">:</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="n">LOW</span><span class="p">,</span> <span class="n">HIGH</span><span class="p">)</span>
        <span class="n">axis</span> <span class="o">=</span> <span class="s1">&#39;x&#39;</span>
    <span class="k">elif</span> <span class="n">orientation</span> <span class="o">==</span> <span class="s1">&#39;horizontal&#39;</span><span class="p">:</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="n">LOW</span><span class="p">,</span> <span class="n">HIGH</span><span class="p">)</span>
        <span class="n">axis</span> <span class="o">=</span> <span class="s1">&#39;y&#39;</span>

    <span class="k">if</span> <span class="n">fix_ticks</span><span class="p">:</span>
        <span class="n">tools</span><span class="o">.</span><span class="n">fix_ticks</span><span class="p">(</span><span class="n">ax</span><span class="p">,</span> <span class="n">ticks</span><span class="o">=</span><span class="n">centres</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="n">axis</span><span class="p">)</span></div>


<div class="viewcode-block" id="plot_hist_from_counts"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.plot_hist.plot_hist_from_counts">[docs]</a><span class="k">def</span> <span class="nf">plot_hist_from_counts</span><span class="p">(</span>
        <span class="n">list_counts</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">]],</span>
        <span class="n">bins</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span>
        <span class="n">list_err</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Union</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">]]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">sample_labels</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">column_label</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">unit</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">column</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">colors</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">alpha</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">float</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">bar_mode</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span> <span class="n">density</span><span class="p">:</span> <span class="n">Density</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">factor_ymax</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">ymin_at_0</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">show_leg</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">bool</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">loc_leg</span><span class="o">=</span><span class="s1">&#39;best&#39;</span><span class="p">,</span>
        <span class="n">orientation</span><span class="o">=</span><span class="s1">&#39;vertical&#39;</span><span class="p">,</span> <span class="n">logscale</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
        <span class="n">ax</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">kwargs_gen</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
        <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">mpl</span><span class="o">.</span><span class="n">figure</span><span class="o">.</span><span class="n">Figure</span><span class="p">,</span> <span class="n">mpl</span><span class="o">.</span><span class="n">axes</span><span class="o">.</span><span class="n">Axes</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot; Produce one plot of histogram(s) from the bin counts directly.</span>

<span class="sd">    Args:</span>
<span class="sd">        list_counts, list_err : bin counts or list of bin counts,</span>
<span class="sd">            and errors (uncertainty) on them</span>
<span class="sd">        bins : Common bin centres or bin edges</span>
<span class="sd">        sample_labels : labels to add to the histogram</span>
<span class="sd">        column_label : label of the column, used in the label of the</span>
<span class="sd">            x-axis</span>
<span class="sd">        unit : unit of the physical quantity, added to the label of the</span>
<span class="sd">            x-axis (between parentheses)</span>
<span class="sd">        column : name of the column that is being plotted. Can be</span>
<span class="sd">            provided to look for a proper label, if ``column_label`` is not</span>
<span class="sd">            given.</span>
<span class="sd">        colors : colour of each histogram</span>
<span class="sd">        alpha : transparency of the histograms. Set at 0.5 of there</span>
<span class="sd">            are several histograms and if no value is provided.</span>
<span class="sd">        bar_mode : whether to plot each histogram</span>
<span class="sd">            using bars, or using points (with error bars in this case)</span>
<span class="sd">        density : 3 kinds of normalisation are possible</span>

<span class="sd">            * ``candidates`` : just divide by the total number of counts</span>
<span class="sd">            * ``bin_width`` : just divide by the bin width (pretty weird)</span>
<span class="sd">            * ``both``: divide by the total number of counts and by the</span>
<span class="sd">                bin width</span>

<span class="sd">            This variable is merely used for the label of the y-axis!</span>
<span class="sd">        factor_ymax : multiplicative factor of the default maximum</span>
<span class="sd">            of the y-axis. If no values are assigned, it is set to</span>
<span class="sd">            `1 + 0.15 * (# histograms)`</span>
<span class="sd">        ymin_at_0 : whether the minimum value of the y-axis  is set at 0</span>
<span class="sd">        show_leg : whether to show the legend.  By default,</span>
<span class="sd">            the legend is shown only if the `sample_labels` are given.</span>
<span class="sd">        loc_leg : location of the legend.</span>
<span class="sd">        orientation : `horizontal` or `vertical`, orientation of the</span>
<span class="sd">            histogram</span>
<span class="sd">        logscale: whether the y-axis is in logscale</span>
<span class="sd">        ax: axis where to plot</span>
<span class="sd">        kwargs_gen: arguments are passed to :py:func:`plot_hist_alone`.</span>
<span class="sd">        **kwargs: keyworked arguments, where each key (argument name)</span>
<span class="sd">            is associated with a list of values, each value being assigned to</span>
<span class="sd">            each histogram and passed to :py:func:`plot_one_hist_from_counts`.</span>
<span class="sd">            If it is not a list, the same value is assigned to all the</span>
<span class="sd">            histograms</span>

<span class="sd">    Returns:</span>
<span class="sd">        :</span>

<span class="sd">        * fig:  Figure of the plot (only if ``ax`` is not specified)</span>
<span class="sd">        * ax: Axis of the plot (only if ``ax`` is not specified)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">assert</span> <span class="n">orientation</span> <span class="ow">in</span> <span class="p">[</span><span class="s2">&quot;vertical&quot;</span><span class="p">,</span> <span class="s2">&quot;horizontal&quot;</span><span class="p">]</span>
    <span class="k">if</span> <span class="n">kwargs_gen</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">kwargs_gen</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="c1"># ax</span>
    <span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">tools</span><span class="o">.</span><span class="n">get_fig_ax</span><span class="p">(</span><span class="n">ax</span><span class="p">,</span> <span class="n">orientation</span><span class="p">)</span>

    <span class="c1"># colors</span>
    <span class="k">if</span> <span class="n">colors</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">colors</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;r&#39;</span><span class="p">,</span> <span class="s1">&#39;b&#39;</span><span class="p">,</span> <span class="s1">&#39;g&#39;</span><span class="p">,</span> <span class="s1">&#39;k&#39;</span><span class="p">]</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">colors</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
        <span class="n">colors</span> <span class="o">=</span> <span class="p">[</span><span class="n">colors</span><span class="p">]</span>

    <span class="k">if</span> <span class="n">show_leg</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">show_leg</span> <span class="o">=</span> <span class="n">sample_labels</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span>

    <span class="c1"># One bin counts / weights / colours -&gt; list of them</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">list_counts</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
        <span class="n">list_counts</span> <span class="o">=</span> <span class="p">[</span><span class="n">list_counts</span><span class="p">]</span>
    <span class="n">nb_histograms</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">list_counts</span><span class="p">)</span>
    <span class="n">bar_mode</span> <span class="o">=</span> <span class="n">el_to_list</span><span class="p">(</span><span class="n">bar_mode</span><span class="p">,</span> <span class="n">nb_histograms</span><span class="p">)</span>
    <span class="n">sample_labels</span> <span class="o">=</span> <span class="n">el_to_list</span><span class="p">(</span><span class="n">sample_labels</span><span class="p">,</span> <span class="n">nb_histograms</span><span class="p">)</span>
    <span class="n">alpha</span> <span class="o">=</span> <span class="n">el_to_list</span><span class="p">(</span><span class="n">alpha</span><span class="p">,</span> <span class="n">nb_histograms</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">counts</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">list_counts</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">alpha</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">alpha</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="mf">0.5</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">counts</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="k">else</span> <span class="mi">1</span>
        <span class="n">err</span> <span class="o">=</span> <span class="kc">None</span> <span class="k">if</span> <span class="n">list_err</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">list_err</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
        <span class="n">label</span> <span class="o">=</span> <span class="kc">None</span> <span class="k">if</span> <span class="n">sample_labels</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">sample_labels</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>

        <span class="c1"># kwargs</span>
        <span class="n">kwargs_i</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">value</span><span class="p">,</span> <span class="p">(</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">)):</span>
                <span class="n">kwargs_i</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">value</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">kwargs_i</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">value</span>

        <span class="n">plot_one_hist_from_counts</span><span class="p">(</span>
            <span class="n">ax</span><span class="p">,</span> <span class="n">counts</span><span class="o">=</span><span class="n">counts</span><span class="p">,</span> <span class="n">err</span><span class="o">=</span><span class="n">err</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="n">colors</span><span class="p">[</span><span class="n">i</span><span class="p">],</span>
            <span class="n">bins</span><span class="o">=</span><span class="n">bins</span><span class="p">,</span> <span class="n">bar_mode</span><span class="o">=</span><span class="n">bar_mode</span><span class="p">[</span><span class="n">i</span><span class="p">],</span>
            <span class="n">alpha</span><span class="o">=</span><span class="n">alpha</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">label</span><span class="o">=</span><span class="n">label</span><span class="p">,</span>
            <span class="n">orientation</span><span class="o">=</span><span class="n">orientation</span><span class="p">,</span>
            <span class="o">**</span><span class="n">kwargs_i</span><span class="p">,</span>
            <span class="o">**</span><span class="n">kwargs_gen</span>
        <span class="p">)</span>

    <span class="n">y_axis</span> <span class="o">=</span> <span class="s1">&#39;y&#39;</span> <span class="k">if</span> <span class="n">orientation</span> <span class="o">==</span> <span class="s2">&quot;vertical&quot;</span> <span class="k">else</span> <span class="s1">&#39;x&#39;</span>
    <span class="k">if</span> <span class="n">logscale</span><span class="p">:</span>
        <span class="n">tools</span><span class="o">.</span><span class="n">set_log_scale</span><span class="p">(</span>
            <span class="n">ax</span><span class="p">,</span> <span class="n">y_axis</span>
        <span class="p">)</span>

    <span class="c1"># Some plot style configuration</span>
    <span class="k">if</span> <span class="n">factor_ymax</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">factor_ymax</span> <span class="o">=</span> <span class="mi">1</span> <span class="o">+</span> <span class="mf">0.15</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">list_counts</span><span class="p">)</span>

    <span class="n">set_label_hist</span><span class="p">(</span>
        <span class="n">ax</span><span class="p">,</span> <span class="n">column_label</span><span class="o">=</span><span class="n">column_label</span><span class="p">,</span> <span class="n">unit</span><span class="o">=</span><span class="n">unit</span><span class="p">,</span>
        <span class="n">column</span><span class="o">=</span><span class="n">column</span><span class="p">,</span>
        <span class="n">bin_width</span><span class="o">=</span><span class="n">bins</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">bins</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span>
        <span class="n">density</span><span class="o">=</span><span class="n">density</span><span class="p">,</span>
        <span class="n">orientation</span><span class="o">=</span><span class="n">orientation</span>
    <span class="p">)</span>

    <span class="n">tools</span><span class="o">.</span><span class="n">show_grid</span><span class="p">(</span><span class="n">ax</span><span class="p">)</span>
    <span class="n">tools</span><span class="o">.</span><span class="n">change_range_axis</span><span class="p">(</span>
        <span class="n">ax</span><span class="o">=</span><span class="n">ax</span><span class="p">,</span>
        <span class="n">factor_max</span><span class="o">=</span><span class="n">factor_ymax</span><span class="p">,</span>
        <span class="n">min_to_0</span><span class="o">=</span><span class="n">ymin_at_0</span><span class="p">,</span>
        <span class="n">axis</span><span class="o">=</span><span class="n">y_axis</span><span class="p">,</span>
        <span class="n">logscale</span><span class="o">=</span><span class="n">logscale</span>
    <span class="p">)</span>
    <span class="k">if</span> <span class="n">logscale</span><span class="p">:</span>
        <span class="n">tools</span><span class="o">.</span><span class="n">set_log_scale</span><span class="p">(</span><span class="n">ax</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="n">y_axis</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">show_leg</span><span class="p">:</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="n">loc_leg</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">fig</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">fig</span><span class="p">,</span> <span class="n">ax</span></div>


<div class="viewcode-block" id="plot_hist"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.plot_hist.plot_hist">[docs]</a><span class="k">def</span> <span class="nf">plot_hist</span><span class="p">(</span>
        <span class="n">samples</span><span class="p">:</span> <span class="n">SamplesLike</span><span class="p">,</span>
        <span class="n">column</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">weights</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">]]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">low</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">float</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">high</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">float</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">bins</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">]</span> <span class="o">=</span> <span class="mi">100</span><span class="p">,</span>
        <span class="n">density</span><span class="p">:</span> <span class="n">Density</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">equal_yield_bins</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
        <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Union</span><span class="p">[</span><span class="n">mpl</span><span class="o">.</span><span class="n">figure</span><span class="o">.</span><span class="n">Figure</span><span class="p">,</span> <span class="n">mpl</span><span class="o">.</span><span class="n">axes</span><span class="o">.</span><span class="n">Axes</span><span class="p">]]:</span>
    <span class="sd">&quot;&quot;&quot; Plot histogram(s) from samples.</span>

<span class="sd">    Args:</span>
<span class="sd">        samples : one Pandas dataframe or a list of Pandas DataFrame,</span>
<span class="sd">            or a series of numbers or a list of them</span>
<span class="sd">        column : name of the columns to plot, in the case one of the</span>
<span class="sd">            sample given is a full dataframe from which we must only select</span>
<span class="sd">            one column</span>
<span class="sd">        low : low limit of the distribution</span>
<span class="sd">            (only if ``bins`` is not the array of bin edges)</span>
<span class="sd">        low : high limit of the distribution</span>
<span class="sd">            (only if ``bins`` is not the array of bin edges)</span>
<span class="sd">        bins : Desired number of bins of the histogram, or bin edges</span>
<span class="sd">        weights (np.array or str, or list of them) : weights passed</span>
<span class="sd">            to  :py:func:`np.histogram`, or name of a column</span>
<span class="sd">            in the dataframes of `samples`</span>
<span class="sd">        density : 3 kinds of normalisation are possible</span>

<span class="sd">        * ``candidates`` : just divide by the total number of counts</span>
<span class="sd">        * ``bin_width`` : just divide by the bin width (pretty weird)</span>
<span class="sd">        * ``both``: divide by the total number of counts and by the \</span>
<span class="sd">        bin width</span>

<span class="sd">        equal_yield_bins: whether to use equal-yield bins</span>
<span class="sd">        **kwargs : passed to :py:func:`plot_hist_from_counts`</span>

<span class="sd">    Returns:</span>
<span class="sd">        :</span>

<span class="sd">        * fig:  Figure of the plot (only if ``ax`` is not specified)</span>
<span class="sd">        * ax: Axis of the plot (only if ``ax`` is not specified)</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">list_counts</span><span class="p">,</span> <span class="n">list_err</span><span class="p">,</span> <span class="n">edges</span> <span class="o">=</span> <span class="n">dataframes_into_hist_1d</span><span class="p">(</span>
        <span class="n">samples</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="n">column</span><span class="p">,</span>
        <span class="n">bins</span><span class="o">=</span><span class="n">bins</span><span class="p">,</span> <span class="n">low</span><span class="o">=</span><span class="n">low</span><span class="p">,</span> <span class="n">high</span><span class="o">=</span><span class="n">high</span><span class="p">,</span> <span class="n">weights</span><span class="o">=</span><span class="n">weights</span><span class="p">,</span>
        <span class="n">density</span><span class="o">=</span><span class="n">density</span><span class="p">,</span>
        <span class="n">equal_yield_bins</span><span class="o">=</span><span class="n">equal_yield_bins</span>
    <span class="p">)</span>

    <span class="k">return</span> <span class="n">plot_hist_from_counts</span><span class="p">(</span>
        <span class="n">list_counts</span><span class="o">=</span><span class="n">list_counts</span><span class="p">,</span> <span class="n">list_err</span><span class="o">=</span><span class="n">list_err</span><span class="p">,</span>
        <span class="n">column</span><span class="o">=</span><span class="n">column</span><span class="p">,</span>
        <span class="n">density</span><span class="o">=</span><span class="n">density</span><span class="p">,</span>
        <span class="n">bins</span><span class="o">=</span><span class="n">edges</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span>
    <span class="p">)</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>